Public Class Form1
    Inherits System.Windows.Forms.Form
    '1.1 TIFF compression tag's definitions.
    '==========================================================================================
    Const AP_TIFF_COMPRESSION_NONE = 0      'No compression.
    Const AP_TIFF_COMPRESSION_LZW = 1       '1,4,8,24bits(default 4,8,24bits)
    Const AP_TIFF_COMPRESSION_JPEG = 2      'Grayscale 8bits,24bits
    Const AP_TIFF_COMPRESSION_PACKBITS = 3  '4,8,24bits
    Const AP_TIFF_COMPRESSION_CCITTG4 = 4   '1bit(default 1bit)
    Const AP_TIFF_COMPRESSION_CCITTG3 = 5   '1bit
    Const AP_TIFF_COMPRESSION_RLE = 6       '1bit
    '==========================================================================================

    '1.2 Image type's definitions
    '=======================================================================================
    Const AP_IMAGE_BMP = 1    'BMP
    Const AP_IMAGE_EMF = 2    'EMF
    Const AP_IMAGE_WMF = 3    'WMF
    Const AP_IMAGE_JPG = 4    'JPG
    Const AP_IMAGE_PNG = 5    'PNG
    Const AP_IMAGE_GIF = 6    'GIF
    Const AP_IMAGE_TIF = 7    'TIF
    Const AP_IMAGE_PCX = 8    'PCX

    Const AP_IMAGE_JPEG = 4   'JPEG
    Const AP_IMAGE_TIFF = 7   'TIFF
    '=======================================================================================

    '1.3 Return code's definitions.
    '==========================================================================================
    Const RTN_OK = 1           'Successful operation.
    Const ERR_UNKNOWN = -99    'Unknown system error.

    Const ERR_OVER_MAXTHREADS = -1     'Over the limit amount of threads
    Const ERR_FILE_UNEXIST = -2        'Source PDF file unexist.
    Const ERR_FILE_DAMAGED = -3        'Source PDF file is damaged.
    Const ERR_FILE_RESTRICTED = -4     'Source PDF file is restricted.

    Const ERR_INVALID_PAGE = -5      'The PDF page is invalid.
    Const ERR_CONVERT_FAILURE = -8   'Conversion failure.
    Const ERR_INVALID_STREAM = -9    'Invalid memory stream address.
    Const ERR_INVALID_HANDLE = -10   'Invalid converter's handle.
    '==========================================================================================


    '1.4 Windows API definitions.
    '==========================================================================================
    Private Declare Function GetTickCount Lib "kernel32" () As Integer
    Private Declare Function GetCurrentProcess Lib "kernel32" () As Integer
    Private Declare Function ReadProcessMemory Lib "kernel32" (ByVal hProcess As Integer, ByVal lpBaseAddress As Integer, ByVal lpBuffer() As Byte, ByVal nSize As Integer, ByRef lpNumberOfBytesWritten As Integer) As Integer
    '==========================================================================================


#Region " Windows"

    Public Sub New()
        MyBase.New()

        InitializeComponent()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents btnDemo1 As System.Windows.Forms.Button
    Friend WithEvents m_ProgressBar As System.Windows.Forms.ProgressBar
    Friend WithEvents btnDemo2 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnDemo1 = New System.Windows.Forms.Button
        Me.m_ProgressBar = New System.Windows.Forms.ProgressBar
        Me.btnDemo2 = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'btnDemo1
        '
        Me.btnDemo1.Location = New System.Drawing.Point(40, 40)
        Me.btnDemo1.Name = "btnDemo1"
        Me.btnDemo1.TabIndex = 0
        Me.btnDemo1.Text = "demo1"
        '
        'm_ProgressBar
        '
        Me.m_ProgressBar.Location = New System.Drawing.Point(0, 96)
        Me.m_ProgressBar.Name = "m_ProgressBar"
        Me.m_ProgressBar.Size = New System.Drawing.Size(440, 23)
        Me.m_ProgressBar.TabIndex = 1
        '
        'btnDemo2
        '
        Me.btnDemo2.Location = New System.Drawing.Point(152, 40)
        Me.btnDemo2.Name = "btnDemo2"
        Me.btnDemo2.TabIndex = 2
        Me.btnDemo2.Text = "demo2"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 14)
        Me.ClientSize = New System.Drawing.Size(440, 118)
        Me.Controls.Add(Me.btnDemo2)
        Me.Controls.Add(Me.m_ProgressBar)
        Me.Controls.Add(Me.btnDemo1)
        Me.Cursor = System.Windows.Forms.Cursors.Arrow
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.Text = "AP Pdf2Image ActiveX Control Library Demo!"
        Me.ResumeLayout(False)

    End Sub

#End Region


    'Demo1 - To convert all pages of the pdf document.
    Private Sub btnDemo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDemo1.Click
        Dim m_AxPdf2Image As New AP_PDF2IMAGE.AxPdf2ImageClass
        Dim nHandle As Integer
        Dim sFileName As String
        Dim iStartTick, iEndTick As Integer
        Dim iPageNo, iPageCount As Integer

        sFileName = "sample.pdf"
        iStartTick = GetTickCount

        'Open pdf document and creating a converter.
        nHandle = m_AxPdf2Image.apOpen(sFileName, "", "")
        Select Case nHandle
            Case ERR_OVER_MAXTHREADS
                MsgBox("Over the limit amount of threads,please waiting!")
                Exit Sub
            Case ERR_FILE_UNEXIST
                MsgBox("Source pdf file unexist!")
                Exit Sub
            Case ERR_FILE_DAMAGED
                MsgBox("Source pdf file damaged!")
                Exit Sub
            Case ERR_FILE_RESTRICTED
                MsgBox("Source pdf file restricted!")
                Exit Sub
        End Select

        'Setting proerties.
        m_AxPdf2Image.sOutDirectory = "./demo1"
        m_AxPdf2Image.iImageType = AP_IMAGE_PNG
        m_AxPdf2Image.iXDPI = 130
        m_AxPdf2Image.iYDPI = 130

        'To convert all pages of the pdf document.
        iPageCount = m_AxPdf2Image.apGetPageCount(nHandle)
        For iPageNo = 1 To iPageCount
            m_AxPdf2Image.apConvertPage(nHandle, iPageNo)

            'Setting conversion's progress.
            m_ProgressBar.Value = Math.Round((iPageNo * 1.0#) / iPageCount * 100)
        Next

        'Close pdf document and destory the converter.
        m_AxPdf2Image.apClose(nHandle)

        'To count conversion's time(ms).
        iEndTick = GetTickCount()
        MsgBox("Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!")
    End Sub

    'Demo2 - To convert appointed pdf pages of the pdf document to memory stream.
    Private Sub btnDemo2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDemo2.Click
        Dim m_AxPdf2Image As New AP_PDF2IMAGE.AxPdf2ImageClass
        Dim nHandle As Integer
        Dim sFileName, sImgFile As String
        Dim iStartTick, iEndTick, iPageCount, iPos As Integer
        Dim m_Pages(6) As Integer
        m_Pages(0) = 1
        m_Pages(1) = 3
        m_Pages(2) = 6
        m_Pages(3) = 8
        m_Pages(4) = 9
        m_Pages(5) = 11

        sFileName = "sample.pdf"
        iStartTick = GetTickCount()

        'Open pdf file and creating a converter.
        nHandle = m_AxPdf2Image.apOpen("sample.pdf", "", "")
        Select Case nHandle
            Case ERR_OVER_MAXTHREADS
                MsgBox("Over the limit amount of threads,please waiting!")
                Exit Sub
            Case ERR_FILE_UNEXIST
                MsgBox("Source pdf file unexist!")
                Exit Sub
            Case ERR_FILE_DAMAGED
                MsgBox("Source pdf file damaged!")
                Exit Sub
            Case ERR_FILE_RESTRICTED
                MsgBox("Source pdf file restricted!")
                Exit Sub
        End Select

        'Setting proerties.
        m_AxPdf2Image.iImageType = AP_IMAGE_JPEG
        m_AxPdf2Image.iQuality = 60
        m_AxPdf2Image.iXDPI = 110
        m_AxPdf2Image.iYDPI = 110
        m_AxPdf2Image.iXDimensions = 995
        m_AxPdf2Image.iYDimensions = 1287

        System.IO.Directory.CreateDirectory("./demo2")
        iPageCount = UBound(m_Pages)
        For iPos = 0 To iPageCount - 1
            'You can save the image stream to database, to file, or to others, etc.
            m_AxPdf2Image.apConvertPageToStream(nHandle, m_Pages(iPos))

            'Here,it saves the memory stream of the image to bytes buffer
            Dim bBuffer(m_AxPdf2Image.iStreamSize) As Byte
            Dim nBytesRead As Integer
            Dim iCurrPID = GetCurrentProcess()  'Current Process ID.
            ReadProcessMemory(iCurrPID, m_AxPdf2Image.iStreamHandle, bBuffer, m_AxPdf2Image.iStreamSize, nBytesRead)

            'Here,it saves the buffer to file.
            If nBytesRead > 0 Then
                sImgFile = "./demo2/myimg_" + CStr(m_Pages(iPos)) + ".jpg"

                Dim fileStream As System.IO.FileStream
                fileStream = New System.IO.FileStream(sImgFile, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.Write)
                fileStream.Write(bBuffer, 0, nBytesRead)
                fileStream.Close()
            End If

            'Setting conversion's progress.
            m_ProgressBar.Value = Math.Round(((iPos + 1) * 1.0#) / iPageCount * 100)
        Next

        'Close pdf document and destory the converter.
        m_AxPdf2Image.apClose(nHandle)

        'To count conversion's time(ms).
        iEndTick = GetTickCount()
        MsgBox("Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!")
    End Sub
End Class
