/***************************************************************************
 *   File:	apconvert.h                                                    *
 *   Purpose:	General Purpose Header File.                               *
 *   Other information: For more information, please visit at our site.    *
 *   Adultpdf.Inc home page: http://www.adultpdf.com                       *
 ***************************************************************************/

//1.1 SDK interface definitions.
//==========================================================================================
typedef long __stdcall _FapOpen(char *pFileName,char *pOwnerPw,char *pUserPw);
typedef long __stdcall _FapClose(long nHandle);
typedef long __stdcall _FapConvert(long nHandle);
typedef long __stdcall _FapConvertPage(long nHandle,long nPageNo);
typedef long __stdcall _FapConvertPageToStream(long nHandle,long nPageNo,BYTE *&pMemStream,long &nSize);
typedef long __stdcall _FapSetProperty(long  nHandle, //Conversion object's handle.
                                       long  nIndex,  //Property tag,refer to the following property definitions.
                                       char *pValue,  //A String value of the property,(or)
                                       long  nValue,  //An integer value of the property.
                                       long  nOther); //Only valid for progress call-back.
typedef long __stdcall _FapGetProperty(long  nHandle, //Conversion object's handle.
                                       long  nIndex,  //Property tag,refer to the following property definitions.
                                       char *pValue,  //A String value of the property,(or)
                                       long &nValue); //An integer value of the property
//==========================================================================================

//1.2 Definitions of converter's properties 
//==========================================================================================
//read/write properties
const long AP_PROP_OUTDIR       = 1;  //Destination directory.
const long AP_PROP_PREFIX       = 2;  //The prefix of the name of result image file.
const long AP_PROP_PAGEZOOM     = 3;  //Zoom scale of the source pdf page.
const long AP_PROP_BGCOLOR      = 4;  //Image background color.
const long AP_PROP_IMAGETYPE    = 5;  //Result image format.
const long AP_PROP_BITCOUNT     = 6;  //Color bits per pixel.
const long AP_PROP_XDPI         = 7;  //Horizontal resolution.
const long AP_PROP_YDPI         = 8;  //Vertical resolution.
const long AP_PROP_QUALITY      = 9;  //JPEG compression quality.
const long AP_PROP_COMPRESSION  = 10; //TIFF compression mode.
const long AP_PROP_MULTIPAGES   = 11; //Multipages TIFF file.
const long AP_PROP_GRAYSCALE    = 12; //Grayscale image.
const long AP_PROP_XDIMENSIONS  = 13; //The width of the result image in pixel
const long AP_PROP_YDIMENSIONS  = 14; //The height of the result image in pixel

//read only properties
const long AP_PROP_PAGECOUNT  = 20; //The total pages of source pdf file.
const long AP_PROP_PAGEHEIGHT = 21; //Height of the current page of source pdf file.
const long AP_PROP_PAGEWIDTH  = 22; //Width of the current page of source pdf file.

//write only properties
const long AP_PROP_PROGRESSFUNC = 40; //Address of the progress call-back function.
//==========================================================================================

//1.3 TIFF tag definitions.
//==========================================================================================
const long AP_TIFF_COMPRESSION_NONE     = 0;  //No compression.
const long AP_TIFF_COMPRESSION_LZW      = 1;  //1,4,8,24bits(default 4,8,24bits)
const long AP_TIFF_COMPRESSION_JPEG     = 2;  //Grayscale 8bits,24bits
const long AP_TIFF_COMPRESSION_PACKBITS = 3;  //4,8,24bits
const long AP_TIFF_COMPRESSION_CCITTG4  = 4;  //1bit(default 1bit)
const long AP_TIFF_COMPRESSION_CCITTG3  = 5;  //1bit
const long AP_TIFF_COMPRESSION_RLE      = 6;  //1bit
//==========================================================================================

//1.4 Image type definitions
//=======================================================================================
const long AP_IMAGE_BMP  = 1;   //BMP
const long AP_IMAGE_EMF  = 2;   //EMF
const long AP_IMAGE_WMF  = 3;   //WMF
const long AP_IMAGE_JPG  = 4;   //JPG
const long AP_IMAGE_PNG  = 5;   //PNG
const long AP_IMAGE_GIF  = 6;   //GIF
const long AP_IMAGE_TIF  = 7;   //TIF
const long AP_IMAGE_PCX  = 8;   //PCX

const long AP_IMAGE_JPEG = 4;   //JPEG
const long AP_IMAGE_TIFF = 7;   //TIFF
//=======================================================================================

//1.5 Return code definitions.
//==========================================================================================
const long RTN_OK = 1;           //Successful operation.
const long ERR_UNKNOWN = -99;    //Unknown system error.

const long ERR_OVER_MAXTHREADS    = -1;  //Over the limit amount of threads
const long ERR_FILE_UNEXIST       = -2;  //Source PDF file unexist.
const long ERR_FILE_DAMAGED       = -3;  //Source PDF file is damaged.
const long ERR_FILE_RESTRICTED    = -4;  //Source PDF file is restricted.

const long ERR_INVALID_PAGE    = -5;   //The PDF page is invalid.
const long ERR_CONVERT_FAILURE = -8;   //Conversion failure.
const long ERR_INVALID_STREAM  = -9;   //Invalid memory stream address.
const long ERR_INVALID_HANDLE  = -10;  //The handle of conversion object is invalid.
//==========================================================================================
